- Qt 6.6
- Qt GRPC
- C++ Classes
- QtGrpc (Technical Preview)
- QGrpcOperation
- Qt 6.6.1 Reference Documentation

# QGrpcOperation Class

The QGrpcOperation class implements common logic to handle communication in Grpc channel. More...

Header: | #include <QGrpcOperation>
CMake: | find_package(Qt6 REQUIRED COMPONENTS Grpc) target_link_libraries(mytarget PRIVATE Qt6::Grpc)
Since: | Qt 6.5
Inherits: | QObject
Inherited By: | QGrpcCallReply and QGrpcStream
Status: | Technical Preview

- List of all members, including inherited members

## Public Functions

QGrpcMetadata | metadata() const
T | read() const
void | setData(const QByteArray &data)
void | setData(QByteArray &&data)
void | setMetadata(const QGrpcMetadata &metadata)
void | setMetadata(QGrpcMetadata &&metadata)

## Signals

void | errorOccurred(const QGrpcStatus &status)
void | finished()

## Detailed Description

## Member Function Documentation

### `[signal]` void QGrpcOperation::errorOccurred(const QGrpcStatus &status)

This signal indicates the error occurred during serialization.

This signal is emitted when error with status occurs in channel or during serialization.

### `[signal]` void QGrpcOperation::finished()

This signal indicates the end of communication for this call.

If signal emitted by stream this means that stream is successfully closed either by client or server.

### QGrpcMetadata QGrpcOperation::metadata() const

Getter of the metadata received from the channel. For the HTTP2 channels it usually contains the HTTP headers received from the server.

See also setMetadata().

### template <typename T> T QGrpcOperation::read() const

Reads message from raw byte array stored in QGrpcCallReply.

Returns a copy of the deserialized message or, on failure, a default-constructed message.

### void QGrpcOperation::setData(const QByteArray &data)

Interface for implementation of QAbstractGrpcChannel.

Should be used to write raw data from channel to reply data raw data received from channel.

### void QGrpcOperation::setData(QByteArray &&data)

Interface for implementation of QAbstractGrpcChannel.

Should be used to write raw data from channel to reply data raw data received from channel.

### void QGrpcOperation::setMetadata(const QGrpcMetadata &metadata)

Interface for implementation of QAbstractGrpcChannel.

Should be used to write metadata from channel to reply metadata received from channel. For the HTTP2 channels it usually contains the HTTP headers received from the server.

See also metadata().

### void QGrpcOperation::setMetadata(QGrpcMetadata &&metadata)

Interface for implementation of QAbstractGrpcChannel.

Should be used to write metadata from channel to reply metadata received from channel. For the HTTP2 channels it usually contains the HTTP headers received from the server.